package gui;

import javax.swing.*;
import javax.swing.border.Border;

import java.awt.*;
import java.awt.event.*;
import data.Data;
import solutions.*;

public class JanelaPrincipal extends JFrame implements ActionListener{

	private JTextArea display;
	private JScrollPane scroll;
	private JTextField alfa, peso, vizinhos, graspMax, btMax, lBtSize, cityFile, vehicleFile;
	private JLabel lalfa, lpeso, lvizinhos, lgraspMax, lbtMax, llBtSize, lcityFile, lvehicleFile;
	private JButton clear, execute;
	private boolean executing;
	
	public JanelaPrincipal() {
		super("Resoluo do PRV via GRASP - Busca Tabu");
		Container c = getContentPane();
		c.setLayout(new BorderLayout());
		
		display = new JTextArea();
		display.setEditable(false);
		scroll = new JScrollPane(display);
		c.add(scroll);
		int n = 75;
		
		JPanel p = new JPanel(new GridLayout(9,1));
		p.setBorder(BorderFactory.createTitledBorder("Parmetros"));
		lcityFile = new JLabel("Arquivo de cidades");
		p.add(lcityFile);
		cityFile = new JTextField(n);
		cityFile.setText("arquivos/vrp8.txt");
		p.add(cityFile);
		lvehicleFile = new JLabel("Arquivo de veculos");
		p.add(lvehicleFile);
		vehicleFile = new JTextField(n);
		vehicleFile.setText("arquivos/caminhoes.txt");
		p.add(vehicleFile);
		lalfa = new JLabel("Alfa (GRASP)");
		p.add(lalfa);
		alfa = new JTextField(n);
		alfa.setText("0.7");
		p.add(alfa);
		lpeso = new JLabel("Peso (Fo)");
		p.add(lpeso);
		peso = new JTextField(n);
		peso.setText("10000");
		p.add(peso);
		lvizinhos = new JLabel("N de vizinhos avaliados");
		p.add(lvizinhos);
		vizinhos = new JTextField(n);
		vizinhos.setText("10");
		p.add(vizinhos);		
		lgraspMax = new JLabel("GraspMax(n de iteraes)");
		p.add(lgraspMax);
		graspMax = new JTextField(n);
		graspMax.setText("20");
		p.add(graspMax);
		lBtSize = new JTextField(n);
		llBtSize = new JLabel("Tamanho Lista Tabu:");
		p.add(llBtSize);
		p.add(lBtSize);
		lBtSize.setText("10");
		btMax = new JTextField(n);
		lbtMax = new JLabel("BT Max:");
		p.add(lbtMax);
		p.add(btMax);
		btMax.setText("150");
		c.add(p, BorderLayout.NORTH);
		p = new JPanel(new FlowLayout());
		execute = new JButton("Executar");
		execute.addActionListener(this);
		p.add(execute);
		clear = new JButton("Limpar");
		clear.addActionListener(this);
		p.add(clear);
		c.add(p, BorderLayout.SOUTH);
		
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
		
		this.setResizable(false);
		setSize(400,500);
		centraliza();
		show();		
	}
	
	private void centraliza() {
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension d = tk.getScreenSize();
		int x = (int)((d.getWidth() - this.getWidth()) / 2);
		int y = (int)((d.getHeight() - this.getHeight()) / 2); 
		this.setLocation(x,y);
	}
	
	public void appendSolution(Solution s) {
		appendDisplay("\nSoluo encontrada:");
		appendDisplay("\n" + s);
		
	}
	
	public void appendDisplay(String st) {
		display.append(st);
	}
	
	public void clearDisplay() {
		display.setText("");
	}
	
	public void execute() {
		clearDisplay();
		Data.citiesFile = cityFile.getText();
		Data.trucksFile = vehicleFile.getText();
		Data.setPeso(Integer.parseInt(peso.getText()));
		Data.setVizinhos(Integer.parseInt(vizinhos.getText()));
		Data.setVizinhos(Integer.parseInt(graspMax.getText()));
		Data.setLBtSize(Integer.parseInt(lBtSize.getText()));
		Data.setBtMax(Integer.parseInt(btMax.getText()));
		Heuristics he = new Heuristics();
		he.grasp();
		appendDisplay("Executando...\n");
		appendDisplay("\nArquivo de cidades: " + cityFile.getText());
		appendDisplay("\nArquivo de veculos: " + vehicleFile.getText());
		appendDisplay("\nPeso da restrio: " + peso.getText());
		appendDisplay("\nN de vizinhos: " + vizinhos.getText());
		appendDisplay("\nN de iteraes(GraspMax): " + graspMax.getText() + "\n");
		appendDisplay("\nGRASP com BUSCA TABU...");
		appendSolution(he.getSstar());
	}
	
	public void clear() {
		clearDisplay();
		
	}
	
	private boolean valited() {
		return true;
	}
	
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == execute) 
		 	if(valited()) {
		 		execute();
		 	}
		else if(e.getSource() == clear)
			clear();
	}
	

	public static void main(String[] args) {
		new JanelaPrincipal();
	}
}
