package model;

import data.*;
import java.util.*;

public class Route implements Cloneable {

	private Vector cities = new Vector();

	public void insert(int id) {
		cities.add(new City(id));
	}

	public boolean set(int pos, int id) {
		if (pos < 0 || pos >= cities.size()){
			cities.add(new City(id));
			return true;
		}	
		cities.add(pos, new City(id));
		return true;
	}

	public int remove(int pos) {
		if (pos < 0 || pos >= cities.size())
			return -1;
		return ((City) cities.remove(pos)).getId();
	}
	
	public int get(int i) {
		return ((City)cities.get(i)).getId();
	}

	public int getDistance() {
		Data d = Data.getPRVData();
		int size = d.getDistancia(0, ((City) cities.firstElement()).getId());
		int n = cities.size() - 1;
		for (int i = 0; i < n; i++) {
			size += d.getDistancia(((City) cities.get(i)).getId(),((City) cities.get(i + 1)).getId());
		}
		size += d.getDistancia(((City) cities.lastElement()).getId(), 0);
		return size;
	}
	
	public int getNumOfCities() {
		return cities.size();
	}
   
    public Object clone() throws CloneNotSupportedException {
    	Route rt = (Route)super.clone();
    	rt.cities = new Vector();
    	for(int i=0; i<cities.size(); i++) {
    		rt.cities.add(((City)cities.get(i)).clone());
    	}
    	return rt;
    }
    
	public String toString() {
		String s ="";
		int n = cities.size();
		for(int i=0; i<n; i++) {
			if(i>0) s+=" - ";
			s += cities.get(i);
		}
		return s;
	}
}
