package model;

import data.*;

public class Vehicle implements Cloneable {

	private Route rt = new Route();
	private int id;
	private int capacity;
	private int cost;
	
	private int capVar;

	public Vehicle(int id, int cap, int cost) {
		this.id = id;
		this.capacity = capVar = cap;
		this.cost = cost;
	}

	public boolean insert(int c) {
		Data d = Data.getPRVData();
		int de = d.getDemanda(c);
		if (capVar < de)
			return false;
		rt.insert(c);
		d.setVisit(c);
		capVar -= de;
		return true;
	}

	public boolean set(int pos, int id) {
		if (rt.set(pos,id)) {
			capVar -= Data.getPRVData().getDemanda(id);
			return true; 
		}
		else return false;
	}
	
	public int remove(int pos) {
		int d = rt.remove(pos); 
		if(d == -1) return -1;
		capVar += Data.getPRVData().getDemanda(d);
		return d;
	}
	
	public int getFORout() {
		//return rt.getDistance();
		return (capVar < 0)? ( (-1) * capVar + Data.getPRVData().getPeso() + rt.getDistance() * getCost()) : (capVar + rt.getDistance() * getCost()); 
	}
	
	public int sizeOfRoute() {
		return rt.getNumOfCities();
	}

	/**
	 * @return
	 */
	public int getCapacity() {
		return capacity;
	}

	/**
	 * @return
	 */
	public int getCost() {
		return cost;
	}

	/**
	 * @return
	 */
	public int getId() {
		return id;
	}
	
	public Object clone() throws CloneNotSupportedException {
		Vehicle t = (Vehicle)super.clone();
		t.rt = (Route)rt.clone();
		return t;
	}
	
	public String toString() {
		String s =" Veculo " + (id+1) + " \tCapacidade: " + capacity + "\tSobra: " + (capVar)+ "\nRota: " + rt;
		return s;
	}

}
