/*
 * Created on 28/11/2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package solutions;

import data.Data;
import model.*;
import util.*;
import java.util.*;

public class Heuristics {
	private Data data;
    private Solution sstar;
	private double alfa;
    private Solution vizinho;

	public void setAlfa(double a) {
		alfa = a;
	}

	public double getAlfa() {
		return alfa;
	}

	public Solution getSstar() {
		return sstar;
	}

	public Heuristics() {
		data = Data.getPRVData();
	}

	public Solution construction() {
		Solution s = new Solution();
		data.clearStatus();
		int n_cid;
		int list[];
		while (data.getNCidades() > data.getNumOfVisited()) {
			int c = Data.random(data.getNCaminhoes());
			System.out.println("caminhao " + c);
			Vehicle t = new Vehicle(c, data.getCapacityOfTruck(c), data.getCostOfTruck(c));
			s.setTruck(t);
			int id_cid = 0;
			do {
				list = data.getNotVisited();
				n_cid = list.length;
				if (n_cid == 0)
					break;
				Merge.mergeSort(list, 0, n_cid - 1, id_cid);
				int min = 0;
				int max = n_cid-1;
				int lcr = (int) (min + alfa * (max - min));
				id_cid = list[ Data.random(0, lcr) ];
			} while (t.insert(id_cid));
		}
		return s;
	}

	public Solution randomizedDownHillMethod(Solution s) {
	    Solution result = null;
		for(int i = 0; i < Data.getVizinhos();i++) {
		   result = s.getVizinho();
		   if(result.getFo() < s.getFo()) {
		   	  s = result;
		   }
		}
		return s;
	}

	public void grasp() {
		int graspMax = Data.getGraspMax();
		sstar = new Solution();
		sstar.setFo(10000);
		for(int i=0; i<graspMax; i++) {
			Solution s = construction();
			System.out.println("Construcao fo " + s.getFo());
			s = randomizedDownHillMethod(s);//buscaTabu(s);//*/= randomizedDownHillMethod(s);
			System.out.println("BT fo " + s.getFo());
			if(s.getFo() < sstar.getFo()) {
				sstar = s;
			}
			System.out.println("Sstar fo " + sstar.getFo());
		}
		sstar = buscaTabu(sstar);
	}

	public Solution buscaTabu(Solution sl) {
		Solution s = sl;
		try {
			s = (Solution) s.clone();
		} catch (CloneNotSupportedException e) {
			e.printStackTrace();
		}
		int melhorIter=0, iter=0;
		Vector ltb = new Vector();
		int fo_asp = s.getFo() - 1;
		Vector vizinhos = new Vector();
		Solution _s;
		while(iter - melhorIter < Data.getBtMax()) {
			iter++;
			vizinhos = s.getVizinhanca();
			Collections.sort(vizinhos);
			boolean isTb = false;
			do{
				_s = (Solution)vizinhos.remove(0);
				//System.out.println("nVinzinhos " + vizinhos.size());
				for(int i=0; i<ltb.size(); i++) {
					if(_s.getMv1().compareTo(ltb.get(i)) == 0) {
						isTb = true;
						break;
					}
					else if(_s.getMv2().compareTo(ltb.get(i)) == 0) {
						isTb = true;
						break;
					}
				}
			}while(_s.getFo() <= fo_asp && isTb && vizinhos.size() > 0);
			if(vizinhos.size() == 0)
				continue;
			if(ltb.size() >= Data.getLBtSize()) {
				ltb.remove(0);
				ltb.remove(0);
			}
			ltb.add(_s.getMv1());
			ltb.add(_s.getMv2());
			fo_asp = _s.getFo() - 1;
			//s = _s;
			//System.out.println("S fo " + s.getFo());
			if(_s.getFo() < s.getFo()) {
				//System.out.println("Sstar fo " + s.getFo());
				s = _s;
				melhorIter = iter;
			}
		}
		return s;
	}

	public Solution buscaTabu() {
		Solution s = sstar;
		try {
			s = (Solution) s.clone();
		} catch (CloneNotSupportedException e) {
			e.printStackTrace();
		}
		int melhorIter=0, iter=0;
		Vector ltb = new Vector();
		int fo_asp = s.getFo() - 1;
		Vector vizinhos = new Vector();
		Solution _s;
		while(iter - melhorIter < Data.getBtMax()) {
			iter++;
			vizinhos = s.getVizinhanca();
			Collections.sort(vizinhos);
			boolean isTb = false;
			do{
				_s = (Solution)vizinhos.remove(0);
				//System.out.println("nVinzinhos " + vizinhos.size());
				for(int i=0; i<ltb.size(); i++) {
					if(_s.getMv1().compareTo(ltb.get(i)) == 0) {
						isTb = true;
						break;
					}
					else if(_s.getMv2().compareTo(ltb.get(i)) == 0) {
						isTb = true;
						break;
					}
				}
			}while(_s.getFo() <= fo_asp && isTb && vizinhos.size() > 0);
			if(vizinhos.size() == 0)
				continue;
			if(ltb.size() >= Data.getLBtSize()) {
				ltb.remove(0);
				ltb.remove(0);
			}
			ltb.add(_s.getMv1());
			ltb.add(_s.getMv2());
			fo_asp = _s.getFo() - 1;
			s = _s;
			//System.out.println("S fo " + s.getFo());
			if(s.getFo() < sstar.getFo()) {
				//System.out.println("Sstar fo " + s.getFo());
				sstar = s;
				melhorIter = iter;
			}
		}
		s = sstar;
		return s;
	}

	/**
	 * @param solution
	 */
	public void setSstar(Solution solution) {
		sstar = solution;
	}

}
